Loading...
Searching...
No Matches
utmscale.h File Reference

C API: Universal Time Scale. More...

`#include "unicode/utypes.h"`

Go to the source code of this file.

## Typedefs

typedef enum UDateTimeScale | UDateTimeScale
| `UDateTimeScale` values are used to specify the time scale used for conversion into or out if the universal time scale.
typedef enum UTimeScaleValue | UTimeScaleValue
| `UTimeScaleValue` values are used to specify the time scale values to `utmscale_getTimeScaleValue`.

## Enumerations

enum | UDateTimeScale { UDTS_JAVA_TIME = 0 , UDTS_UNIX_TIME , UDTS_ICU4C_TIME , UDTS_WINDOWS_FILE_TIME , UDTS_DOTNET_DATE_TIME , UDTS_MAC_OLD_TIME , UDTS_MAC_TIME , UDTS_EXCEL_TIME , UDTS_DB2_TIME , UDTS_UNIX_MICROSECONDS_TIME , UDTS_MAX_SCALE }
| `UDateTimeScale` values are used to specify the time scale used for conversion into or out if the universal time scale. More...
enum | UTimeScaleValue { UTSV_UNITS_VALUE = 0 , UTSV_EPOCH_OFFSET_VALUE =1 , UTSV_FROM_MIN_VALUE =2 , UTSV_FROM_MAX_VALUE =3 , UTSV_TO_MIN_VALUE =4 , UTSV_TO_MAX_VALUE =5 , UTSV_EPOCH_OFFSET_PLUS_1_VALUE =6 , UTSV_EPOCH_OFFSET_MINUS_1_VALUE =7 , UTSV_UNITS_ROUND_VALUE =8 , UTSV_MIN_ROUND_VALUE =9 , UTSV_MAX_ROUND_VALUE =10 , UTSV_MAX_SCALE_VALUE =11 }
| `UTimeScaleValue` values are used to specify the time scale values to `utmscale_getTimeScaleValue`. More...

## Functions

U_CAPI int64_t | utmscale_getTimeScaleValue (UDateTimeScale timeScale, UTimeScaleValue value, UErrorCode *status)
| Get a value associated with a particular time scale.
U_CAPI int64_t | utmscale_fromInt64 (int64_t otherTime, UDateTimeScale timeScale, UErrorCode *status)
| Convert a `int64_t` datetime from the given time scale to the universal time scale.
U_CAPI int64_t | utmscale_toInt64 (int64_t universalTime, UDateTimeScale timeScale, UErrorCode *status)
| Convert a datetime from the universal time scale to a `int64_t` in the given time scale.

## Detailed Description

C API: Universal Time Scale.

There are quite a few different conventions for binary datetime, depending on different platforms and protocols. Some of these have severe drawbacks. For example, people using Unix time (seconds since Jan 1, 1970) think that they are safe until near the year 2038. But cases can and do arise where arithmetic manipulations causes serious problems. Consider the computation of the average of two datetimes, for example: if one calculates them with `averageTime = (time1 + time2)/2`, there will be overflow even with dates around the present. Moreover, even if these problems don't occur, there is the issue of conversion back and forth between different systems.

Binary datetimes differ in a number of ways: the datatype, the unit, and the epoch (origin). We'll refer to these as time scales. For example:

Table 1: Binary Time Scales
Source | Datatype | Unit | Epoch
--- | --- | --- | ---
UDTS_JAVA_TIME | int64_t | milliseconds | Jan 1, 1970
UDTS_UNIX_TIME | int32_t or int64_t | seconds | Jan 1, 1970
UDTS_ICU4C_TIME | double | milliseconds | Jan 1, 1970
UDTS_WINDOWS_FILE_TIME | int64_t | ticks (100 nanoseconds) | Jan 1, 1601
UDTS_DOTNET_DATE_TIME | int64_t | ticks (100 nanoseconds) | Jan 1, 0001
UDTS_MAC_OLD_TIME | int32_t or int64_t | seconds | Jan 1, 1904
UDTS_MAC_TIME | double | seconds | Jan 1, 2001
UDTS_EXCEL_TIME | ? | days | Dec 31, 1899
UDTS_DB2_TIME | ? | days | Dec 31, 1899
UDTS_UNIX_MICROSECONDS_TIME | int64_t | microseconds | Jan 1, 1970

All of the epochs start at 00:00 am (the earliest possible time on the day in question), and are assumed to be UTC.

The ranges for different datatypes are given in the following table (all values in years). The range of years includes the entire range expressible with positive and negative values of the datatype. The range of years for double is the range that would be allowed without losing precision to the corresponding unit.

Units | int64_t | double | int32_t
--- | --- | --- | ---
1 sec | 5.84542x1011 | 285,420,920.94 | 136.10
1 millisecond | 584,542,046.09 | 285,420.92 | 0.14
1 microsecond | 584,542.05 | 285.42 | 0.00
100 nanoseconds (tick) | 58,454.20 | 28.54 | 0.00
1 nanosecond | 584.5420461 | 0.2854 | 0.00

These functions implement a universal time scale which can be used as a 'pivot', and provide conversion functions to and from all other major time scales. This datetimes to be converted to the pivot time, safely manipulated, and converted back to any other datetime time scale.

So what to use for this pivot? Java time has plenty of range, but cannot represent .NET `System.DateTime` values without severe loss of precision. ICU4C time addresses this by using a `double` that is otherwise equivalent to the Java time. However, there are disadvantages with `doubles`. They provide for much more graceful degradation in arithmetic operations. But they only have 53 bits of accuracy, which means that they will lose precision when converting back and forth to ticks. What would really be nice would be a `long double` (80 bits – 64 bit mantissa), but that is not supported on most systems.

The Unix extended time uses a structure with two components: time in seconds and a fractional field (microseconds). However, this is clumsy, slow, and prone to error (you always have to keep track of overflow and underflow in the fractional field). `BigDecimal` would allow for arbitrary precision and arbitrary range, but we do not want to use this as the normal type, because it is slow and does not have a fixed size.

Because of these issues, we ended up concluding that the .NET framework's `System.DateTime` would be the best pivot. However, we use the full range allowed by the datatype, allowing for datetimes back to 29,000 BC and up to 29,000 AD. This time scale is very fine grained, does not lose precision, and covers a range that will meet almost all requirements. It will not handle the range that Java times do, but frankly, being able to handle dates before 29,000 BC or after 29,000 AD is of very limited interest.

Definition in file utmscale.h.

## Typedef Documentation

## UDateTimeScale

typedef enum UDateTimeScale UDateTimeScale

`UDateTimeScale` values are used to specify the time scale used for conversion into or out if the universal time scale.

Stable
  ICU 3.2

## UTimeScaleValue

typedef enum UTimeScaleValue UTimeScaleValue

`UTimeScaleValue` values are used to specify the time scale values to `utmscale_getTimeScaleValue`.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

## Enumeration Type Documentation

## UDateTimeScale

enum UDateTimeScale

`UDateTimeScale` values are used to specify the time scale used for conversion into or out if the universal time scale.

Stable
  ICU 3.2

Enumerator

UDTS_JAVA_TIME

Used in the JDK.

Data is a Java `long` (`int64_t`). Value is milliseconds since January 1, 1970.

Stable
  ICU 3.2

UDTS_UNIX_TIME

Used on Unix systems.

Data is `int32_t` or `int64_t`. Value is seconds since January 1, 1970.

Stable
  ICU 3.2

UDTS_ICU4C_TIME

Used in IUC4C.

Data is a `double`. Value is milliseconds since January 1, 1970.

Stable
  ICU 3.2

UDTS_WINDOWS_FILE_TIME

Used in Windows for file times.

Data is an `int64_t`. Value is ticks (1 tick == 100 nanoseconds) since January 1, 1601.

Stable
  ICU 3.2

UDTS_DOTNET_DATE_TIME

Used in the .NET framework's `System.DateTime` structure.

Data is an `int64_t`. Value is ticks (1 tick == 100 nanoseconds) since January 1, 0001.

Stable
  ICU 3.2

UDTS_MAC_OLD_TIME

Used in older Macintosh systems.

Data is `int32_t` or `int64_t`. Value is seconds since January 1, 1904.

Stable
  ICU 3.2

UDTS_MAC_TIME

Used in newer Macintosh systems.

Data is a `double`. Value is seconds since January 1, 2001.

Stable
  ICU 3.2

UDTS_EXCEL_TIME

Used in Excel.

Data is an `?unknown?`. Value is days since December 31, 1899.

Stable
  ICU 3.2

UDTS_DB2_TIME

Used in DB2.

Data is an `?unknown?`. Value is days since December 31, 1899.

Stable
  ICU 3.2

UDTS_UNIX_MICROSECONDS_TIME

Data is a `long`.

Value is microseconds since January 1, 1970. Similar to Unix time (linear value from 1970) and struct timeval (microseconds resolution).

Stable
  ICU 3.8

UDTS_MAX_SCALE

The first unused time scale value.

The limit of this enum

Deprecated
  ICU 59 The numeric value may change over time, see ICU ticket #12420.

Definition at line 204 of file utmscale.h.

## UTimeScaleValue

enum UTimeScaleValue

`UTimeScaleValue` values are used to specify the time scale values to `utmscale_getTimeScaleValue`.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

Enumerator

UTSV_UNITS_VALUE

The constant used to select the units vale for a time scale.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

UTSV_EPOCH_OFFSET_VALUE

The constant used to select the epoch offset value for a time scale.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

UTSV_FROM_MIN_VALUE

The constant used to select the minimum from value for a time scale.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

UTSV_FROM_MAX_VALUE

The constant used to select the maximum from value for a time scale.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

UTSV_TO_MIN_VALUE

The constant used to select the minimum to value for a time scale.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

UTSV_TO_MAX_VALUE

The constant used to select the maximum to value for a time scale.

See also
  utmscale_getTimeScaleValue

Stable
  ICU 3.2

UTSV_EPOCH_OFFSET_PLUS_1_VALUE

The constant used to select the epoch plus one value for a time scale.

NOTE: This is an internal value. DO NOT USE IT. May not actually be equal to the epoch offset value plus one.

See also
  utmscale_getTimeScaleValue

Internal
  Do not use. This API is for internal use only. ICU 3.2

UTSV_EPOCH_OFFSET_MINUS_1_VALUE

The constant used to select the epoch plus one value for a time scale.

NOTE: This is an internal value. DO NOT USE IT. May not actually be equal to the epoch offset value plus one.

See also
  utmscale_getTimeScaleValue

Internal
  Do not use. This API is for internal use only. ICU 3.2

UTSV_UNITS_ROUND_VALUE

The constant used to select the units round value for a time scale.

NOTE: This is an internal value. DO NOT USE IT.

See also
  utmscale_getTimeScaleValue

Internal
  Do not use. This API is for internal use only. ICU 3.2

UTSV_MIN_ROUND_VALUE

The constant used to select the minimum safe rounding value for a time scale.

NOTE: This is an internal value. DO NOT USE IT.

See also
  utmscale_getTimeScaleValue

Internal
  Do not use. This API is for internal use only. ICU 3.2

UTSV_MAX_ROUND_VALUE

The constant used to select the maximum safe rounding value for a time scale.

NOTE: This is an internal value. DO NOT USE IT.

See also
  utmscale_getTimeScaleValue

Internal
  Do not use. This API is for internal use only. ICU 3.2

UTSV_MAX_SCALE_VALUE

The number of time scale values, in other words limit of this enum.

See also
  utmscale_getTimeScaleValue

Deprecated
  ICU 59 The numeric value may change over time, see ICU ticket #12420.

Definition at line 304 of file utmscale.h.

## Function Documentation

## utmscale_fromInt64()

U_CAPI int64_t utmscale_fromInt64 | ( | int64_t | otherTime,
|  | UDateTimeScale | timeScale,
|  | UErrorCode * | status )

Convert a `int64_t` datetime from the given time scale to the universal time scale.

Parameters

  otherTime | The `int64_t` datetime
  timeScale | The time scale to convert from
  status | The status code. Set to `U_ILLEGAL_ARGUMENT_ERROR` if the conversion is out of range.

Returns
  The datetime converted to the universal time scale

Stable
  ICU 3.2

References U_CAPI.

## utmscale_getTimeScaleValue()

U_CAPI int64_t utmscale_getTimeScaleValue | ( | UDateTimeScale | timeScale,
|  | UTimeScaleValue | value,
|  | UErrorCode * | status )

Get a value associated with a particular time scale.

Parameters

  timeScale | The time scale
  value | A constant representing the value to get
  status | The status code. Set to `U_ILLEGAL_ARGUMENT_ERROR` if arguments are invalid.

Returns
  - the value.

Stable
  ICU 3.2

References U_CAPI.

## utmscale_toInt64()

U_CAPI int64_t utmscale_toInt64 | ( | int64_t | universalTime,
|  | UDateTimeScale | timeScale,
|  | UErrorCode * | status )

Convert a datetime from the universal time scale to a `int64_t` in the given time scale.

Parameters

  universalTime | The datetime in the universal time scale
  timeScale | The time scale to convert to
  status | The status code. Set to `U_ILLEGAL_ARGUMENT_ERROR` if the conversion is out of range.

Returns
  The datetime converted to the given time scale

Stable
  ICU 3.2